// stdafx.cpp : source file that includes just the standard includes
//  stdafx.pch will be the pre-compiled header
//  stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"

#ifdef _ATL_STATIC_REGISTRY
#include <statreg.h>
#include <statreg.cpp>
#endif

#include <atlimpl.cpp>

CChatDiscussionList::CChatDiscussionList() : m_map(), m_cs()
{
   m_cs.Init();
}

CChatDiscussionList::~CChatDiscussionList()
{
   m_cs.Term();
}

bool CChatDiscussionList::AddDiscussion(wchar_t *pwszDiscussion, IUnknown *pUnk)
{
   bool bRc = false ;
   m_cs.Lock();
   USES_CONVERSION;
   string strKey = W2A(pwszDiscussion);
   DiscussionMap::iterator index = m_map.find(strKey);
   if (index==m_map.end()) {
      pUnk->AddRef();
      // Discussion server has not been added
      // Add the Discussion into the map
      m_map.insert(DiscussionMap::value_type(strKey, pUnk));
      bRc = true ;
   }
   m_cs.Unlock();

   return bRc ; 
}

void CChatDiscussionList::RemoveDiscussion(wchar_t *pwszDiscussion)
{
   m_cs.Lock();
   DiscussionMap::iterator index;
   USES_CONVERSION;
   string strKey = W2A(pwszDiscussion);
   index = m_map.find(strKey);
   if (index!=m_map.end()) {
      // Discussion found. Release the interface pointer.
      IUnknown *pUnk = (*index).second;
      pUnk->Release();
      // Remove the Discussion from the map.
      m_map.erase(index);
   }
   m_cs.Unlock();
}

wchar_t *CChatDiscussionList::GetDiscussionList()
{
   m_cs.Lock();
   // Create the list of Discussions
   DiscussionMap::iterator index;
   string strDiscussionList;
   for (index = m_map.begin(); index != m_map.end(); index++) {
      strDiscussionList += (*index).first;
      strDiscussionList += string("\n");
   }

   wchar_t *pRetList = (wchar_t*)CoTaskMemAlloc((strDiscussionList.size()+1)*2);
   if (pRetList) {
      USES_CONVERSION;
      wcscpy(pRetList, A2W(strDiscussionList.data()));
   } else {
      pRetList = NULL;
   }
   m_cs.Unlock();

   return pRetList;
}

IUnknown *CChatDiscussionList::GetChatServer(wchar_t *pwszDiscussion)
{
   IUnknown *pUnk=NULL; // Assume discussion doesnt exist.

   m_cs.Lock();

   DiscussionMap::iterator index;
   USES_CONVERSION;
   string strKey = W2A(pwszDiscussion);
   // Find the IUnknown pointer.
   index = m_map.find(strKey);
   if (index!=m_map.end()) {
      // Found the discussion.
      pUnk = (*index).second;
      pUnk->AddRef(); // AddRef for the client
   }

   m_cs.Unlock();
   return pUnk;
}

long CChatDiscussionList::GetSize()
{
   return m_map.size();
}
