// ATLCyberOcr.h : Declaration of the CATLCyberOcr

#ifndef __ATLCYBEROCR_H_
#define __ATLCYBEROCR_H_

#include "resource.h"       // main symbols
#include <atlctl.h>

#include "..\..\include\RemPtr.h "
EXTERN_C const CLSID CLSID_OcrProcessor;

/////////////////////////////////////////////////////////////////////////////
// CATLCyberOcr
class ATL_NO_VTABLE CATLCyberOcr : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IATLCyberOcr, &IID_IATLCyberOcr, &LIBID_ATLCYBERSERVERLib>,
	public CComControl<CATLCyberOcr>,
	public IPersistStreamInitImpl<CATLCyberOcr>,
	public IOleControlImpl<CATLCyberOcr>,
	public IOleObjectImpl<CATLCyberOcr>,
	public IOleInPlaceActiveObjectImpl<CATLCyberOcr>,
	public IViewObjectExImpl<CATLCyberOcr>,
	public IOleInPlaceObjectWindowlessImpl<CATLCyberOcr>,
	public CComCoClass<CATLCyberOcr, &CLSID_ATLCyberOcr>
{
public:
	CContainedWindow m_ctlStatic;
	

	CATLCyberOcr() :	
		m_ctlStatic(_T("Static"), this, 1)
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ATLCYBEROCR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CATLCyberOcr)
	COM_INTERFACE_ENTRY(IATLCyberOcr)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
END_COM_MAP()

BEGIN_PROP_MAP(CATLCyberOcr)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CATLCyberOcr)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	CHAIN_MSG_MAP(CComControl<CATLCyberOcr>)
ALT_MSG_MAP(1)
	// Replace this with message map entries for superclassed Static
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);


	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lRes = CComControl<CATLCyberOcr>::OnSetFocus(uMsg, wParam, lParam, bHandled);
		if (m_bInPlaceActive)
		{
			DoVerbUIActivate(&m_rcPos,  NULL);
			if(!IsChild(::GetFocus()))
				m_ctlStatic.SetFocus();
		}
		return lRes;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		RECT rc;
		GetWindowRect(&rc);
		rc.right -= rc.left;
		rc.bottom -= rc.top;
		rc.top = rc.left = 0;
		m_ctlStatic.Create(m_hWnd, rc);
		return 0;
	}
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<CATLCyberOcr>::SetObjectRects(prcPos, prcClip);
		int cx, cy;
		cx = prcPos->right - prcPos->left;
		cy = prcPos->bottom - prcPos->top;
		::SetWindowPos(m_ctlStatic.m_hWnd, NULL, 0,
			0, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE);
		return S_OK;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IATLCyberOcr
public:
	STDMETHOD(OcrImage)(/*[in]*/ BSTR Image, /*[out, retval]*/ BSTR *pText);
	STDMETHOD(get_OCRServerName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_OCRServerName)(/*[in]*/ BSTR newVal);

private:
   CComBSTR m_OCRServerName;
   RemotePtr<IOcrProcessor, &CLSID_OcrProcessor, 
             &IID_IOcrProcessor> m_pRemoteOcr; 
};

#endif //__ATLCYBEROCR_H_
