// ImagingWindow.cpp : implementation file
//

#include "stdafx.h"
#include "MFCCyberServer.h"
#include "ImagingWindow.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImagingWindow dialog


CImagingWindow::CImagingWindow(CWnd* pParent /*=NULL*/)
	: CDialog(CImagingWindow::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImagingWindow)
	//}}AFX_DATA_INIT
}


void CImagingWindow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImagingWindow)
	DDX_Control(pDX, IDC_EDIT_TEXT, m_EditOcrText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImagingWindow, CDialog)
	//{{AFX_MSG_MAP(CImagingWindow)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(ID_BUTTON_BROWSE, OnButtonBrowse)
	ON_COMMAND(ID_BUTTON_FIT_BEST, OnButtonFitBest)
	ON_COMMAND(ID_BUTTON_FIT_WIDTH, OnButtonFitWidth)
	ON_COMMAND(ID_BUTTON_OCR, OnButtonOcr)
	ON_COMMAND(ID_BUTTON_ROTATE, OnButtonRotate)
	ON_COMMAND(ID_BUTTON_ZOOM, OnButtonZoom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImagingWindow message handlers

int CImagingWindow::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
   m_Toolbar.Create(this);
   m_Toolbar.LoadToolBar(IDR_TOOLBAR_IMAGING); 
   m_Image.Create(0, 0, WS_VISIBLE|WS_CHILD, CRect(), this, IDC_CTRL_IMAGE);
   
	return 0;
}

void CImagingWindow::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
   if (IsWindowVisible()) {
      int dy=(int)(cy*.5), bar=30, pad=3;
      m_Toolbar.MoveWindow(0,0,cx,bar);
      m_Image.MoveWindow(0,bar,cx,dy);
      m_EditOcrText.MoveWindow(0,dy+bar+pad,cx,cy-dy-bar-pad);
   }
	
}

void CImagingWindow::OnButtonBrowse() 
{
   CFileDialog adtDlg(TRUE,0,0,0, _T("TIFF Images(*.tif)|*.tif"));
   if (adtDlg.DoModal()==IDOK) {
      m_Image.SetImage(adtDlg.GetPathName()) ;
      m_Image.Display() ;
   }
   m_Image.RedrawWindow();
}

void CImagingWindow::OnButtonFitBest() 
{
   if (m_Image.GetImageDisplayed()) {
      VARIANT v; v.vt = VT_BOOL; v.boolVal = TRUE;
      m_Image.FitTo(0, v);
      m_Image.RedrawWindow();
   }
}

void CImagingWindow::OnButtonFitWidth() 
{
   if (m_Image.GetImageDisplayed()) {
      VARIANT v; v.vt = VT_BOOL; v.boolVal = TRUE;
      m_Image.FitTo(1, v);
      m_Image.RedrawWindow();
   }
}

char g_szFakeOcrText[10*MAX_PATH] = { 
	"COVERAGES AND LIMITS UNDER YOUR LIBERTYGUARD HOMEOWNERS POLICY\r\n"
    "YOUR DWELLING WITH REPLACEMENT COST\t\t$361,000\r\n"
    "OTHER STRUCTURES ON RESIDENCE PREMISES\t$36,100\r\n"
    "PERSONAL PROPERTY WITH REPLACEMENT COST\t$270,750\r\n"
    "LOSS OF USE OF YOUR RESIDENCE PREMISES\t$108,300\r\n"
    "PERSONAL LIABILITY (EACH OCCURRENCE)\t\t$300,000\r\n"
    "MEDICAL PAYMENTS TO OTHERS (EACH PERSON)\t$1,000\r\n"
    "\r\n"
    "||||||||||||||||||||||||||||||||||||||||||\r\n"
};

void CImagingWindow::OnButtonOcr() 
{
   m_EditOcrText.SetWindowText(g_szFakeOcrText) ;
}

void CImagingWindow::OnButtonRotate() 
{
   if (m_Image.GetImageDisplayed()) {
      m_Image.RotateRight() ;
      m_Image.RedrawWindow();
   }
}

void CImagingWindow::OnButtonZoom() 
{
   if (m_Image.GetImageDisplayed()) {		
      m_Image.ZoomToSelection() ;
      m_Image.RedrawWindow();
      // UpdateWindow();
   }
}
