// PropertyPager.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "PropertyPager.h"

#include "MainFrm.h"
#include "PropertyPagerDoc.h"
#include "PropertyPagerView.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropertyPagerApp

BEGIN_MESSAGE_MAP(CPropertyPagerApp, CWinApp)
	//{{AFX_MSG_MAP(CPropertyPagerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropertyPagerApp construction

CPropertyPagerApp::CPropertyPagerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPropertyPagerApp object

CPropertyPagerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CPropertyPagerApp initialization

BOOL CPropertyPagerApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CPropertyPagerDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CPropertyPagerView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//-------------------------------------------------------------------
// Simply use the AppAbout handler to write our code.
//-------------------------------------------------------------------
#include "CalendarView.h"
#include "CyberServerView.h"
#include <comdef.h>
#include <atlbase.h>

inline void Chk(HRESULT hr) 
{
   if (FAILED(hr)) _com_issue_error(hr);
}

// App command to run the dialog
void CPropertyPagerApp::OnAppAbout()
{
   // Get the IUnknown for the Calendar control
   CCalendarView *pCalView = (CCalendarView *)
       ((CMainFrame*)AfxGetMainWnd())->m_Splitter.GetPane(0,1);
   IUnknown *pUnkCal = pCalView->m_Calendar.GetControlUnknown();

   // Get the IUnknown for the MFCCyberServer control
   CCyberServerView *pCyberView = (CCyberServerView *)
       ((CMainFrame*)AfxGetMainWnd())->m_Splitter.GetPane(0,0);
   IUnknown *pUnkCyber = pCyberView->m_Cyber.GetControlUnknown();


   // Variables to hold CLSIDs of ActiveX controls' property pages
   CAUUID caCalGUID, caCyberGUID;
   GUID *pArrayClsid = 0;


   try {
      CComPtr<ISpecifyPropertyPages> pCalISPP;
      // Get ISpecifyPropertyPages of the Calendar control
      HRESULT hr = pUnkCal->QueryInterface(IID_ISpecifyPropertyPages, 
         (void **)&pCalISPP); Chk(hr);
      // Get the GUIDs for all property pages of the Calendar control
      hr=pCalISPP->GetPages(&caCalGUID);  Chk(hr);


      CComPtr<ISpecifyPropertyPages> pCyberISPP;
      // Get ISpecifyPropertyPages of the MFCCyberServer control
      hr = pUnkCyber->QueryInterface(IID_ISpecifyPropertyPages, 
         (void**)&pCyberISPP); Chk(hr);
      // Get the GUIDs for all property pages of the MFCCyberServer control
      hr=pCyberISPP->GetPages(&caCyberGUID); Chk(hr);



      // Create an array of GUIDs to pass to OleCreatePropertyFrame
      int elems = 2;
      pArrayClsid = new GUID[elems];
      ZeroMemory(pArrayClsid, elems*sizeof(GUID));
      memcpy(&pArrayClsid[0], caCalGUID.pElems, sizeof(GUID));      
      memcpy(&pArrayClsid[1], caCyberGUID.pElems, sizeof(GUID));


      // Array of IUnknown pointers for our ActiveX controls
      IUnknown *ArrayUnk[2] = { pUnkCal, pUnkCyber };

      // Call OleCreatePropertyFrame to display the property pages
      hr = OleCreatePropertyFrame(
               AfxGetMainWnd()->m_hWnd, 
               0, 
               0, 
               OLESTR("Calendar and MFCCyberServer Properties"), 
               sizeof(ArrayUnk)/sizeof(ArrayUnk[0]),
               ArrayUnk, 
               elems,
               pArrayClsid,
               0L, 
               0L, 
               NULL); Chk(hr);
   } catch (_com_error & error) {
      AfxMessageBox(error.ErrorMessage());
   }

   // Clean up after ourselves
   if (pArrayClsid) delete [] pArrayClsid ; 
   if (caCalGUID.pElems) CoTaskMemFree((void *)caCalGUID.pElems);
   if (caCyberGUID.pElems) CoTaskMemFree((void *)caCyberGUID.pElems);
}

/////////////////////////////////////////////////////////////////////////////
// CPropertyPagerApp message handlers

