// OcrProcessor.h : Declaration of the COcrProcessor

#ifndef __OCRPROCESSOR_H_
#define __OCRPROCESSOR_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// COcrProcessor
class ATL_NO_VTABLE COcrProcessor : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<COcrProcessor, &CLSID_OcrProcessor>,
	public IDispatchImpl<IOcrProcessor, &IID_IOcrProcessor, &LIBID_OCRSERVERLib>,
   public IDispatchImpl<IDispSpell, &IID_IDispSpell, &LIBID_OCRSERVERLib>,
   public ISpell
{
public:
	COcrProcessor()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_OCRPROCESSOR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(COcrProcessor)
	COM_INTERFACE_ENTRY(IOcrProcessor)
   COM_INTERFACE_ENTRY2(IDispatch, IOcrProcessor)
   COM_INTERFACE_ENTRY(IDispSpell)
   COM_INTERFACE_ENTRY(ISpell)
END_COM_MAP()

// IOcrProcessor
public:
	STDMETHOD(OcrWholeImage)(/*[in]*/ VARIANT binaryImageArray, /*[out, retval]*/ BSTR *pOcrText);

   
// ISpell
public:
   STDMETHOD(Check)(/*[in, string]*/ wchar_t * pwszWord, 
                   /*[out]*/ struct PossibleWords *pWords);
   
// IDispSpell
public:
   STDMETHOD(Check)() { return S_OK; }

};

#endif //__OCRPROCESSOR_H_
