// SecureOcrClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SecureOcrClient.h"
#include "SecureOcrClientDlg.h"

// Include the proxy/stub code so that we don't have to register it on the client side
#include "../SecureOcrServer/SecureOcrServer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
   CAboutDlg();

// Dialog Data
   //{{AFX_DATA(CAboutDlg)
   enum { IDD = IDD_ABOUTBOX };
   //}}AFX_DATA

   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CAboutDlg)
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);   // DDX/DDV support
   //}}AFX_VIRTUAL

// Implementation
protected:
   //{{AFX_MSG(CAboutDlg)
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
   //{{AFX_DATA_INIT(CAboutDlg)
   //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CAboutDlg)
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
   //{{AFX_MSG_MAP(CAboutDlg)
      // No message handlers
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSecureOcrClientDlg dialog

CSecureOcrClientDlg::CSecureOcrClientDlg(CWnd* pParent /*=NULL*/)
   : CDialog(CSecureOcrClientDlg::IDD, pParent)
{
   //{{AFX_DATA_INIT(CSecureOcrClientDlg)
   m_strUserID = _T("imdis");
   m_strPassword = _T("imdis");
   m_strServer = _T("DOG");
   m_strDomain = _T("");
   //}}AFX_DATA_INIT
   // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSecureOcrClientDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CSecureOcrClientDlg)
   DDX_Control(pDX, IDC_COMBO_AUTH_LEVEL, m_ctrlAuthLevel);
   DDX_Text(pDX, IDC_EDIT_USER_ID, m_strUserID);
   DDV_MaxChars(pDX, m_strUserID, 15);
   DDX_Text(pDX, IDC_EDIT_PASSWORD, m_strPassword);
   DDV_MaxChars(pDX, m_strPassword, 128);
   DDX_Text(pDX, IDC_EDIT_SERVER, m_strServer);
   DDV_MaxChars(pDX, m_strServer, 15);
   DDX_Text(pDX, IDC_EDIT_DOMAIN, m_strDomain);
   DDV_MaxChars(pDX, m_strDomain, 15);
   //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSecureOcrClientDlg, CDialog)
   //{{AFX_MSG_MAP(CSecureOcrClientDlg)
   ON_WM_SYSCOMMAND()
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_BN_CLICKED(IDOK, OnOk)
   ON_EN_CHANGE(IDC_EDIT_SERVER, OnChangeEditServer)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSecureOcrClientDlg message handlers

BOOL CSecureOcrClientDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Add "About..." menu item to system menu.

   // IDM_ABOUTBOX must be in the system command range.
   ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
   ASSERT(IDM_ABOUTBOX < 0xF000);

   CMenu* pSysMenu = GetSystemMenu(FALSE);
   if (pSysMenu != NULL)
   {
      CString strAboutMenu;
      strAboutMenu.LoadString(IDS_ABOUTBOX);
      if (!strAboutMenu.IsEmpty())
      {
         pSysMenu->AppendMenu(MF_SEPARATOR);
         pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
      }
   }

   // Set the icon for this dialog.  The framework does this automatically
   // when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon
   
   // TODO: Add extra initialization here
   wchar_t szComputerName[MAX_COMPUTERNAME_LENGTH+1];
   DWORD dwSize = MAX_COMPUTERNAME_LENGTH+1;
   ::GetComputerNameW(szComputerName, &dwSize);
   m_strLocalComputerName = m_strDomain = m_strServer = szComputerName;

   GetDlgItem(IDC_EDIT_USER_ID)->EnableWindow(FALSE);
   GetDlgItem(IDC_EDIT_PASSWORD)->EnableWindow(FALSE);
   GetDlgItem(IDC_EDIT_DOMAIN)->EnableWindow(FALSE);
   GetDlgItem(IDC_COMBO_AUTH_LEVEL)->EnableWindow(FALSE);

   m_ctrlAuthLevel.SetCurSel(0);
   UpdateData(FALSE);
   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSecureOcrClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
   if ((nID & 0xFFF0) == IDM_ABOUTBOX)
   {
      CAboutDlg dlgAbout;
      dlgAbout.DoModal();
   }
   else
   {
      CDialog::OnSysCommand(nID, lParam);
   }
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.

void CSecureOcrClientDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CSecureOcrClientDlg::OnQueryDragIcon()
{
   return (HCURSOR) m_hIcon;
}


#include <comdef.h>
#include <comutil.h>
#include <atlbase.h>


inline void CHECK_HRESULT(HRESULT hr, IUnknown *pUnk, REFIID riid)
{
/*
   if (FAILED(hr)) {
      _com_issue_errorex(hr, pUnk, riid);
   }
*/
   if (FAILED(hr)) {
      CComQIPtr<ISupportErrorInfo, 
                &IID_ISupportErrorInfo> pSupportError(pUnk);
      HRESULT hrTest = 
         pSupportError->InterfaceSupportsErrorInfo(riid);
      if (FAILED(hrTest)) throw _com_error(hrTest);
      CComPtr<IErrorInfo> pErrorInfo;
      hrTest = ::GetErrorInfo(0, &pErrorInfo);
      if (FAILED(hrTest)) throw _com_error(hrTest);
      throw _com_error(hr, pErrorInfo);
   }
}

inline void CHECK_HRESULT(HRESULT hr)
{
   if (FAILED(hr)) {
      _com_issue_error(hr);
   }
}

void CSecureOcrClientDlg::OnOk() 
{
   // If server and client are on the same machine, 
   // security is ignored.  In this case, security acts
   // as if RPC_C_AUTHN_LEVEL_PKT_PRIVACY is used

   UpdateData(TRUE);
   CWaitCursor w;
   HRESULT hr = S_OK;

   // Get the security information entered by the user
   _bstr_t bstrUser(m_strUserID);
   _bstr_t bstrDomain(m_strDomain);
   _bstr_t bstrPassword(m_strPassword);

   // Set AuthIdentity
   SEC_WINNT_AUTH_IDENTITY_W AuthIdentity = {
      bstrUser,
      bstrUser.length(),
      bstrDomain,
      bstrDomain.length(),
      bstrPassword,
      bstrPassword.length(),
      SEC_WINNT_AUTH_IDENTITY_UNICODE 
   };

   CoInitialize(0);
   try {
      // process wide security - for all proxies not specifically refined
      hr = CoInitializeSecurity(
            NULL,
            -1,
            NULL,
            NULL,
            RPC_C_AUTHN_LEVEL_DEFAULT,  // NTLM promotes this to PACKET
            RPC_C_IMP_LEVEL_IMPERSONATE, // Allow impersonation
            NULL,
            EOAC_NONE,
            NULL);
      CHECK_HRESULT(hr);

      // Internally register the proxy/stub
      // Got to get all the source for the proxy/stub generated by MIDL.
      // Turn of pre-compile header and added rpcrt4.lib into the link settings.
      CComPtr<IUnknown> pUnk;
      hr = DllGetClassObject(IID_ISecureOcrProcessor, IID_IUnknown, (void **)&pUnk);
      CHECK_HRESULT(hr);
      DWORD dwCookie=0;
      hr = CoRegisterClassObject(IID_ISecureOcrProcessor, pUnk, 
         CLSCTX_INPROC_SERVER, REGCLS_MULTIPLEUSE, &dwCookie);
      CHECK_HRESULT(hr);
      hr = CoRegisterPSClsid(IID_ISecureOcrProcessor, IID_ISecureOcrProcessor);
      CHECK_HRESULT(hr);

      // ACTIVATION Security
      _bstr_t bstrServer(m_strServer);
      // Using activation security; i.e., using the indicated 
      // userid and password

      // Set AuthInfo
      // NTLM promotes AUTH_LEVEL to PACKET
      COAUTHINFO AuthInfo = {
         RPC_C_AUTHN_WINNT, 
         RPC_C_AUTHZ_NONE, 
         NULL, 
         m_ctrlAuthLevel.GetCurSel(),   // AUTH_LEVEL entered by user
         RPC_C_IMP_LEVEL_IMPERSONATE, 
         (COAUTHIDENTITY*)&AuthIdentity,
         EOAC_NONE 
      };

      COSERVERINFO csi = {0, bstrServer, &AuthInfo, 0};
      MULTI_QI mqi[] = {&IID_ISecureOcrProcessor, NULL, S_OK};
      hr = CoCreateInstanceEx(CLSID_SecureOcrProcessor, NULL, CLSCTX_SERVER, &csi, 1, mqi);
      CHECK_HRESULT(hr); CHECK_HRESULT(mqi[0].hr);
      CComPtr <ISecureOcrProcessor> pSecureOcr((ISecureOcrProcessor*)mqi[0].pItf);

      // CALL Security
      // Use the default access token - the one that started this
      // client application.  Use the impersonation and authentication
      // level set for the process (CoInitializeSecurity).
      try {
         // This call should fail because no encryption is used.
         // Our server expects the call to be totally encrypted.
         hr = pSecureOcr->SecureOcrImage();
         CHECK_HRESULT(hr, pSecureOcr, IID_ISecureOcrProcessor);
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            ::MessageBox(NULL, er.Description(), TEXT("Description"), MB_OK);
         } else {
            ::MessageBox(NULL, er.ErrorMessage(), TEXT("ErrorMessage"), MB_OK);
         }
      }

      // Dynamically refine the security of the proxy using
      // the entered userid and password given by user.  
      // We are changing security for this specific proxy.
      // If you want to preserve the original security context for
      // this proxy, you should first call CoCopyProxy.
      hr = CoSetProxyBlanket(pSecureOcr, // Apply the security on this proxy
         RPC_C_AUTHN_WINNT, RPC_C_AUTHZ_NONE, NULL,
         m_ctrlAuthLevel.GetCurSel(),  // Use the AUTH_LEVEL selected.
         RPC_C_IMP_LEVEL_IMPERSONATE,  // Allow impersonation.
         &AuthIdentity,  // Using a specific AuthIdentity.
         EOAC_NONE);
      CHECK_HRESULT(hr);
      // Calling with customized security.
      try {
         // This call will succeed or fail, depending on what the auth level selected.
         hr = pSecureOcr->SecureOcrImage();
         CHECK_HRESULT(hr, pSecureOcr, IID_ISecureOcrProcessor);
      } catch(_com_error & er) {
         if (er.Description().length()>0) {
            ::MessageBox(NULL, er.Description(), TEXT("Description"), MB_OK);
         } else {
            ::MessageBox(NULL, er.ErrorMessage(), TEXT("ErrorMessage"), MB_OK);
         }
      }
   } catch(_com_error & er) {
      ::MessageBox(NULL, er.ErrorMessage(), TEXT("ErrorMessage"), MB_OK);
   }

   CoUninitialize();
}

void CSecureOcrClientDlg::OnChangeEditServer() 
{
   GetDlgItemText(IDC_EDIT_SERVER, m_strServer);
   BOOL b = TRUE ;
   (m_strServer==m_strLocalComputerName) ? b=FALSE : b=TRUE;
   // disable all controls
   GetDlgItem(IDC_EDIT_USER_ID)->EnableWindow(b);
   GetDlgItem(IDC_EDIT_PASSWORD)->EnableWindow(b);
   GetDlgItem(IDC_EDIT_DOMAIN)->EnableWindow(b);
   GetDlgItem(IDC_COMBO_AUTH_LEVEL)->EnableWindow(b);
}
